Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #1188 (closed defect: fixed)

Opened 12 years ago

Last modified 11 years ago

Can connect to the AP, but network doensn't work.

Reported by: zauberschloss@gmail.com Assigned to:
Priority: major Milestone: version 0.9.5
Component: madwifi: other Version: v0.9.2.1
Keywords: Cc:
Patch is attached: 1 Pending:

Description

I'm having some problems setting a wireless network consisting of a gentoo ap, one gentoo station and one Windows XP station.

I've followed the instructions on the madwifi.org and on gentoo specialized forums and wiki. Seems like the "wireless" part of the network is just fine and every station can connect to the ap, but I can't do more than ping the hosts in the winxp station and the gentoo station connects to the network but can't do nothing... not even ping the ap. Nothing wrong with logs and signal... but it seems that all the network services and protocols (tcp, udp and icmp for the gentoo station) aren't working.

The strange thing is that the Windows XP host can ping the ap, however it can't get a dhcp address and even using static IP can't access services on the AP like http and ssh. This machine can ping hosts on the internet but can't access tcp or udp services. Iptraf on the AP reports the connections.

The other Gentoo workstation can scan and connect to the network but can't do nothing more.

One important information is that I'm not using any kind of criptografy or authentication like wep or wpa.

From the AP Linux Machine:

/etc/conf.d/wireless:

modules_ath0=( "iwconfig" )
config_ath0=( "169.254.0.1/16" )
mode_ath0="Master"
essid_ath0="skyshaper"
channel_ath0="10"
iwpriv_ath0=( "mode 3" )

dns_domain_skyshaper="local"
dns_servers_skyshaper=( "169.254.0.1" )

dmesg relevant parts:

ath_hal: module license 'Proprietary' taints kernel.
ath_hal: 0.9.17.2 (AR5210, AR5211, AR5212, RF5111, RF5112, RF2413, RF5413)
ath_rate_sample: 1.2 (0.9.2.1)
ath_pci: 0.9.4.5 (0.9.2.1)
wifi0: 11b rates: 1Mbps 2Mbps 5.5Mbps 11Mbps
wifi0: 11g rates: 1Mbps 2Mbps 5.5Mbps 11Mbps 6Mbps 9Mbps 12Mbps 18Mbps
24Mbps 36Mbps 48Mbps 54Mbps
wifi0: turboG rates: 6Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: H/W encryption support: WEP AES AES_CCM TKIP
wifi0: mac 7.9 phy 4.5 radio 5.6
wifi0: Use hw queue 1 for WME_AC_BE traffic
wifi0: Use hw queue 0 for WME_AC_BK traffic
wifi0: Use hw queue 2 for WME_AC_VI traffic
wifi0: Use hw queue 3 for WME_AC_VO traffic
wifi0: Use hw queue 8 for CAB traffic
wifi0: Use hw queue 9 for beacons
wifi0: Atheros 5212: mem=0xdfdc0000, irq=11

lspci -vv relevant parts:

00:0e.0 Ethernet controller: Atheros Communications, Inc. AR5212
802.11abg NIC (rev 01)
       Subsystem: D-Link System Inc D-Link AirPlus DWL-G520 Wireless
PCI Adapter(rev.B)
       Control: I/O- Mem+ BusMaster+ SpecCycle- MemWINV+ VGASnoop-
ParErr- Stepping- SERR+ FastB2B-
       Status: Cap+ 66MHz- UDF- FastB2B+ ParErr- DEVSEL=medium
>TAbort- <TAbort- <MAbort- >SERR- <PERR-
       Latency: 168 (2500ns min, 7000ns max), Cache Line Size: 32 bytes
       Interrupt: pin A routed to IRQ 11
       Region 0: Memory at dfdc0000 (32-bit, non-prefetchable) [size=64K]
       Capabilities: [44] Power Management version 2
               Flags: PMEClk- DSI- D1- D2- AuxCurrent=375mA
PME(D0-,D1-,D2-,D3hot-,D3cold-)
               Status: D0 PME-Enable- DSel=0 DScale=2 PME-

iwconfig:

ath0      IEEE 802.11g  ESSID:"skyshaper"  Nickname:""
         Mode:Master  Frequency:2.457 GHz  Access Point: 00:19:5B:66:D5:0C
         Bit Rate:0 kb/s   Tx-Power:18 dBm   Sensitivity=0/3
         Retry:off   RTS thr:off   Fragment thr:off
         Encryption key:off
         Power Management:off
         Link Quality=55/94  Signal level=-40 dBm  Noise level=-95 dBm
         Rx invalid nwid:354  Rx invalid crypt:0  Rx invalid frag:0
         Tx excessive retries:0  Invalid misc:0   Missed beacon:0

ifconfig:

ath0      Link encap:Ethernet  HWaddr 00:19:5B:66:D5:0C
         inet addr:169.254.0.1  Bcast:169.254.255.255  Mask:255.255.0.0
         UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
         RX packets:125 errors:0 dropped:0 overruns:0 frame:0
         TX packets:99 errors:0 dropped:6 overruns:0 carrier:0
         collisions:0 txqueuelen:0
         RX bytes:13311 (12.9 Kb)  TX bytes:9901 (9.6 Kb)

lo        Link encap:Local Loopback
         inet addr:127.0.0.1  Mask:255.0.0.0
         UP LOOPBACK RUNNING  MTU:16436  Metric:1
         RX packets:8 errors:0 dropped:0 overruns:0 frame:0
         TX packets:8 errors:0 dropped:0 overruns:0 carrier:0
         collisions:0 txqueuelen:0
         Expansion ROM at dfde0000 [disabled] [size=64K]
         RX bytes:574 (574.0 b)  TX bytes:574 (574.0 b)

nas0      Link encap:Ethernet  HWaddr 00:90:D0:B5:34:F2
         UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
         RX packets:2248 errors:0 dropped:0 overruns:0 frame:0
         TX packets:33 errors:0 dropped:0 overruns:0 carrier:0
         collisions:0 txqueuelen:1000
         RX bytes:134393 (131.2 Kb)  TX bytes:2696 (2.6 Kb)

ppp0      Link encap:Point-to-Point Protocol
         inet addr:201.13.90.211  P-t-P:200.100.11.75  Mask:255.255.255.255
         UP POINTOPOINT RUNNING NOARP MULTICAST  MTU:1492  Metric:1
         RX packets:2238 errors:0 dropped:0 overruns:0 frame:0
         TX packets:20 errors:0 dropped:0 overruns:0 carrier:0
         collisions:0 txqueuelen:3
         RX bytes:115929 (113.2 Kb)  TX bytes:1455 (1.4 Kb)

wifi0     Link encap:UNSPEC  HWaddr
00-19-5B-66-D5-0C-38-70-00-00-00-00-00-00-00-00
         UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
         RX packets:1021 errors:0 dropped:0 overruns:0 frame:694
         TX packets:569 errors:9 dropped:0 overruns:0 carrier:0
         collisions:0 txqueuelen:199
         RX bytes:68997 (67.3 Kb)  TX bytes:62170 (60.7 Kb)
         Interrupt:11 Memory:c8880000-c8890000

Kernel IP routing table:

Destination     Gateway         Genmask         Flags Metric Ref    Use Iface
200.100.11.75   0.0.0.0         255.255.255.255 UH    0      0        0 ppp0
169.254.0.0     0.0.0.0         255.255.0.0     U     0      0        0 ath0
127.0.0.0       0.0.0.0         255.0.0.0       U     0      0        0 lo
0.0.0.0         200.100.11.75   0.0.0.0         UG    0      0        0 ppp0

/proc/net/wireless:

Inter-| sta-|   Quality        |   Discarded packets               | Missed | WE
 iface | tus | link level noise |  nwid  crypt   frag  retry   misc |
beacon | 21
 ath0: 0004   38.  199.  161.     381      0      0      0      0        0

From the Station Linux Machine:

/etc/conf.d/wireless:

mode_ath0="managed"
essid_ath0="skyshaper"
iwconfig_ath0=( "rate 54M" )
iwpriv_ath0=( "mode 3" )

config_ath0=( "169.254.0.3/16" )
routes_ath0=( "default via 169.254.0.1" )
dns_domain_skyshaper="local"
dns_servers_skyshaper="169.254.0.1"

dmesg relevant parts:

ath_hal: module license 'Proprietary' taints kernel.
ath_hal: 0.9.17.2 (AR5210, AR5211, AR5212, RF5111, RF5112, RF2413, RF5413)
wlan: 0.8.4.2 (0.9.2.1)
ath_rate_sample: 1.2 (0.9.2.1)
ath_pci: 0.9.4.5 (0.9.2.1)
wifi0: 11b rates: 1Mbps 2Mbps 5.5Mbps 11Mbps
wifi0: 11g rates: 1Mbps 2Mbps 5.5Mbps 11Mbps 6Mbps 9Mbps 12Mbps 18Mbps
24Mbps 36Mbps 48Mbps 54Mbps
wifi0: turboG rates: 6Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: H/W encryption support: WEP AES AES_CCM TKIP
wifi0: mac 7.9 phy 4.5 radio 5.6
wifi0: Use hw queue 1 for WME_AC_BE traffic
wifi0: Use hw queue 0 for WME_AC_BK traffic
wifi0: Use hw queue 2 for WME_AC_VI traffic
wifi0: Use hw queue 3 for WME_AC_VO traffic
wifi0: Use hw queue 8 for CAB traffic
wifi0: Use hw queue 9 for beacons
wifi0: Atheros 5212: mem=0xefbf0000, irq=20

lspci -vv relevant parts:

03:02.0 Ethernet controller: Atheros Communications, Inc. AR5212
802.11abg NIC (rev 01)
       Subsystem: D-Link System Inc D-Link AirPlus DWL-G520 Wireless
PCI Adapter(rev.B)
       Control: I/O- Mem+ BusMaster+ SpecCycle- MemWINV+ VGASnoop-
ParErr- Stepping- SERR+ FastB2B-
       Status: Cap+ 66MHz- UDF- FastB2B+ ParErr- DEVSEL=medium
>TAbort- <TAbort- <MAbort- >SERR- <PERR-
       Latency: 168 (2500ns min, 7000ns max), Cache Line Size: 64 bytes
       Interrupt: pin A routed to IRQ 20
       Region 0: Memory at efbf0000 (32-bit, non-prefetchable) [size=64K]
       Capabilities: [44] Power Management version 2
               Flags: PMEClk- DSI- D1- D2- AuxCurrent=375mA
PME(D0-,D1-,D2-,D3hot-,D3cold-)
               Status: D0 PME-Enable- DSel=0 DScale=2 PME-

iwconfig

lo        no wireless extensions.

eth0      no wireless extensions.

wifi0     no wireless extensions.

ath0      IEEE 802.11g  ESSID:"skyshaper"  Nickname:"yule"
         Mode:Managed  Frequency:2.457 GHz  Access Point: 00:19:5B:66:D5:0C
         Bit Rate=54 Mb/s   Tx-Power:18 dBm   Sensitivity=0/3
         Retry:off   RTS thr:off   Fragment thr:off
         Encryption key:off
         Power Management:off
         Link Quality=59/94  Signal level=-36 dBm  Noise level=-95 dBm
         Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
         Tx excessive retries:0  Invalid misc:0   Missed beacon:0

ifconfig
ath0      Link encap:Ethernet  HWaddr 00:19:5B:66:D8:B0
         inet addr:169.254.0.3  Bcast:169.254.255.255  Mask:255.255.0.0
         UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
         RX packets:3 errors:0 dropped:0 overruns:0 frame:0
         TX packets:324 errors:0 dropped:0 overruns:0 carrier:0
         collisions:0 txqueuelen:0
         RX bytes:42 (42.0 b)  TX bytes:45610 (44.5 Kb)

wifi0     Link encap:UNSPEC  HWaddr
00-19-5B-66-D8-B0-20-C1-00-00-00-00-00-00-00-00
         UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
         RX packets:22118 errors:0 dropped:0 overruns:0 frame:1164
         TX packets:668 errors:0 dropped:0 overruns:0 carrier:0
         collisions:0 txqueuelen:199
         RX bytes:2799129 (2.6 Mb)  TX bytes:70104 (68.4 Kb)
         Interrupt:20 Memory:f93e0000-f93f0000

Kernel IP routing table:

Destination     Gateway         Genmask         Flags Metric Ref    Use Iface
192.168.0.0     0.0.0.0         255.255.255.0   U     0      0        0 eth0
169.254.0.0     0.0.0.0         255.255.0.0     U     0      0        0 ath0
127.0.0.0       0.0.0.0         255.0.0.0       U     0      0        0 lo
0.0.0.0         192.168.0.1     0.0.0.0         UG    0      0        0 eth0

cat /proc/net/wireless

Inter-| sta-|   Quality        |   Discarded packets               | Missed | WE
 face | tus | link level noise |  nwid  crypt   frag  retry   misc | beacon | 21
 ath0: 0004   60.  221.  161.       0      0      0      0      0        0

Windows Machine:

No bad logs, no problems. It can ping the router ap, ping internet address and even get dns responses from the ap. All other network functions doesn't work.

Both stations reports good signal.

Another thing... I've loaded the ath_pci module with debug options and it gave me lots of (debuging ¬¬) information. When I try to ping (one request with "ping -c 1") the ap from the station it prints the following information in /var/log/messages:

Mar  8 17:43:04 yule ath_tx_start: skb0 f3221680 [data f7b9ac3c len
120] skbaddr 37b9ac3c
Mar  8 17:43:04 yule TODS
00:19:5b:66:d8:b0->00:19:5b:66:d5:0c(00:19:5b:66:d5:0c) data QoS [TID
0] 54M
Mar  8 17:43:04 yule
Mar  8 17:43:04 yule 88 01 2c 00 00 19 5b 66  d5 0c 00 19 5b 66 d8 b0
Mar  8 17:43:04 yule 00 19 5b 66 d5 0c 50 06  00 00 d5 0c aa aa 03 00
Mar  8 17:43:04 yule 00 00 08 00 45 00 00 54  00 00 40 00 40 01 e6 a8
Mar  8 17:43:04 yule a9 fe 00 03 a9 fe 00 01  08 00 27 fc cd 16 00 01
Mar  8 17:43:04 yule 58 75 f0 45 c0 2d 0f 00  08 09 0a 0b 0c 0d 0e 0f
Mar  8 17:43:04 yule 10 11 12 13 14 15 16 17  18 19 1a 1b 1c 1d 1e 1f
Mar  8 17:43:04 yule 20 21 22 23 24 25 26 27  28 29 2a 2b 2c 2d 2e 2f
Mar  8 17:43:04 yule 30 31 32 33 34 35 36 37
Mar  8 17:43:04 yule
Mar  8 17:43:04 yule ath_tx_start: Q1: (ds)f706ae20 (lk)00000000
(d)37b9ac3c (c0)4124007a (c1)06008078 11118000 000db50c
Mar  8 17:43:04 yule ath_tx_txqaddbuf: link[1] (f706adc0)=3706ae20 (f706ae20)

Using tcpdump, the ap reported some "arp-truncated" errors.

What about the "ath_hal: module license 'Proprietary' taints kernel."? I thought the madwifi-ng modules were all open source. The madwifi-ng package version is the latest until now (0.9.2.1). I also tried the svn sources.

I've configured the network as ad-hoc and everyone pings each other, but "higher level" network trafic such as TCP and UDP services wont work correctly.

I don't know what else I can do. From what I know, it should be working but mystical forces are haunting my network.

Oh... and forgive my poor english.

Attachments

ni_state.patch (1.8 kB) - added by Bas on 11/07/07 14:15:53.

Change History

05/24/07 18:20:27 changed by anonymous

I am also experiencing similar problems.

My setup: - AP on Fedora Core 6, AR5212 802.11abg, madwifi 0.9.3-1 from livna.org, kernel 2.6.20-1.2944, using hostapd 0.5.7 with WPA2-PSK - Client: Windows XP SP2 with Intel Pro/Wireless 2200

Description of the problem:

  • Connection established, excellent signal
  • I can ping AP without problem
  • Samba doesn't work
  • interactive SSH works
  • bulk SSH from AP to client hangs after a few seconds. On AP side, TCP is retransmitting packets that the client never receives.

09/22/07 16:40:13 changed by anonymous

I've got a similar problem too.

linux 2.6.20.19, madwifi-ng 0.9.3.2

connected fine, great signal, can get a dhcp lease, but cannot ping ap, nor connect anything else.

Tcpdump shows that arp-requests and dhcp requests get a response, but anything else seems one-way, not even RST packets come back. And my router has no firewalling on the lan..

11/07/07 13:34:57 changed by rozteck@interia.pl

Have you tried to disable the WMM (iwpriv ath0 wmm 0) on the AP? We've got some problems with the Intel cards running on Windows XP driver and the QoS settings they want to achieve. The only way to make everything work was to disable the WMM in madwifi driver. You can also try to disable the fast frames (iwpriv ath0 ff 0) and bursting (iwpriv ath0 burst 0).

11/07/07 14:15:53 changed by Bas

  • attachment ni_state.patch added.

11/07/07 14:16:41 changed by Bas

Hi,

I experienced the same problems when connecting a non-atheros/madwifi based client (Intel/WinXP) to a madwifi based AP.

Turning off Fast Frames (FF) resolved the problem for me. So I took a look in the code, and it seems that on association of a client, the Atheros specific capabilities of the AP are copied to the client, but never cleared. This results in the AP sending FastFrames? to the client, which the client obviously does not understand. In this case, ping will work because the ping packets are small, but full sized packets will be concatenated by the FF code.

I have made some changes to the code to reset the capabilities on association. Please see attached ni_state patch. This fix might apply to some more tickets with vague connection problems as well.

Best regards,

Bas

(follow-up: ↓ 6 ) 11/07/07 14:21:57 changed by Bas

Signed-off-by: Bas

(in reply to: ↑ 5 ; follow-up: ↓ 7 ) 11/07/07 15:37:06 changed by mrenzmann

  • patch_attached set to 1.

Replying to Bas:

Signed-off-by: Bas

Which rises the question whether signing off a patch with a pseudonym rather than a real name and a valid e-mail address makes sense and can be accepted or not...

(in reply to: ↑ 6 ) 11/07/07 17:48:51 changed by Bas

Replying to mrenzmann:

Replying to Bas:

Signed-off-by: Bas

Which rises the question whether signing off a patch with a pseudonym rather than a real name and a valid e-mail address makes sense and can be accepted or not...

Since I am no fan of spam, I don't like to have my email address on a public site... If there is another way of signing off, I am more than happy to do it.

Best regards,

Bas (which is not a pseudonym but my first name...)

11/09/07 07:20:26 changed by mrenzmann

As discussed here signed-off-by lines similar to the above will be accepted as long as it's obvious that it comes from the patch author (which seems to be the case here).

Thanks for submitting the patch.

Team, please review.

11/13/07 18:49:33 changed by mentor

  • status changed from new to closed.
  • resolution set to fixed.
  • milestone set to version 0.9.4.

r2847. Thanks.

02/11/08 06:16:31 changed by mrenzmann

  • milestone changed from version 0.9.4 to version 0.9.5.